Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3606)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3607)
@@ -9141,8 +9465,125 @@
              ENDIF
 
-          CASE ( 'rad_mrt_sw' )
-             IF ( ALLOCATED( mrtinsw_av ) )  THEN
-                mrtinsw_av(:) = mrtinsw_av(:)  / REAL( average_count_3d, KIND=wp )
-             ENDIF
+!--       block of RTM output variables
+          CASE ( 'rtm_rad_net' )
+!--           array of complete radiation balance
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfradnet_av(isurf) = surfinsw_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_insw' )
+!--           array of sw radiation falling to surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinsw_av(isurf) = surfinsw_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_inlw' )
+!--           array of lw radiation falling to surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinlw_av(isurf) = surfinlw_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_inswdir' )
+!--           array of direct sw radiation falling to surface from sun
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinswdir_av(isurf) = surfinswdir_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_inswdif' )
+!--           array of difusion sw radiation falling to surface from sky and borders of the domain
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinswdif_av(isurf) = surfinswdif_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_inswref' )
+!--           array of sw radiation falling to surface from reflections
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinswref_av(isurf) = surfinswref_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_inlwdif' )
+!--           array of sw radiation falling to surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinlwdif_av(isurf) = surfinlwdif_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_inlwref' )
+!--           array of lw radiation falling to surface from reflections
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinlwref_av(isurf) = surfinlwref_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_outsw' )
+!--           array of sw radiation emitted from surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfoutsw_av(isurf) = surfoutsw_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_outlw' )
+!--           array of lw radiation emitted from surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfoutlw_av(isurf) = surfoutlw_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_ressw' )
+!--           array of residua of sw radiation absorbed in surface after last reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfins_av(isurf) = surfins_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_reslw' )
+!--           array of residua of lw radiation absorbed in surface after last reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinl_av(isurf) = surfinl_av(isurf) / REAL( average_count_3d, kind=wp )
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_pc_inlw' )
+              DO l = 1, npcbl
+                 pcbinlw_av(:) = pcbinlw_av(:) / REAL( average_count_3d, kind=wp )
+              ENDDO
+
+          CASE ( 'rtm_rad_pc_insw' )
+              DO l = 1, npcbl
+                 pcbinsw_av(:) = pcbinsw_av(:) / REAL( average_count_3d, kind=wp )
+              ENDDO
+
+          CASE ( 'rtm_rad_pc_inswdir' )
+              DO l = 1, npcbl
+                 pcbinswdir_av(:) = pcbinswdir_av(:) / REAL( average_count_3d, kind=wp )
+              ENDDO
+
+          CASE ( 'rtm_rad_pc_inswdif' )
+              DO l = 1, npcbl
+                 pcbinswdif_av(:) = pcbinswdif_av(:) / REAL( average_count_3d, kind=wp )
+              ENDDO
+
+          CASE ( 'rtm_rad_pc_inswref' )
+              DO l = 1, npcbl
+                 pcbinswref_av(:) = pcbinswref_av(:) / REAL( average_count_3d, kind=wp )
+              ENDDO
 
           CASE ( 'rad_mrt_lw' )
@@ -9170,9 +9611,9 @@
 !> It is called out from subroutine netcdf.
 !------------------------------------------------------------------------------!
-SUBROUTINE radiation_define_netcdf_grid( var, found, grid_x, grid_y, grid_z )
+SUBROUTINE radiation_define_netcdf_grid( variable, found, grid_x, grid_y, grid_z )
     
     IMPLICIT NONE
 
-    CHARACTER (LEN=*), INTENT(IN)  ::  var         !< 
+    CHARACTER (LEN=*), INTENT(IN)  ::  variable    !<
     LOGICAL, INTENT(OUT)           ::  found       !< 
     CHARACTER (LEN=*), INTENT(OUT) ::  grid_x      !< 
@@ -9180,36 +9621,60 @@
     CHARACTER (LEN=*), INTENT(OUT) ::  grid_z      !< 
 
+    CHARACTER (len=varnamelength)  :: var
+
     found  = .TRUE.
 
 !
 !-- Check for the grid
-    SELECT CASE ( TRIM( var ) )
-
-       CASE ( 'rad_lw_cs_hr', 'rad_lw_hr', 'rad_sw_cs_hr', 'rad_sw_hr',        &
-              'rad_lw_cs_hr_xy', 'rad_lw_hr_xy', 'rad_sw_cs_hr_xy',            &
-              'rad_sw_hr_xy', 'rad_lw_cs_hr_xz', 'rad_lw_hr_xz',               &
-              'rad_sw_cs_hr_xz', 'rad_sw_hr_xz', 'rad_lw_cs_hr_yz',            &
-              'rad_lw_hr_yz', 'rad_sw_cs_hr_yz', 'rad_sw_hr_yz',               &
-              'rad_mrt', 'rad_mrt_sw', 'rad_mrt_lw' )
-          grid_x = 'x'
-          grid_y = 'y'
-          grid_z = 'zu'
-
-       CASE ( 'rad_lw_in', 'rad_lw_out', 'rad_sw_in', 'rad_sw_out',            &
-              'rad_lw_in_xy', 'rad_lw_out_xy', 'rad_sw_in_xy','rad_sw_out_xy', &
-              'rad_lw_in_xz', 'rad_lw_out_xz', 'rad_sw_in_xz','rad_sw_out_xz', &
-              'rad_lw_in_yz', 'rad_lw_out_yz', 'rad_sw_in_yz','rad_sw_out_yz' )
-          grid_x = 'x'
-          grid_y = 'y'
-          grid_z = 'zw'
-
-
-       CASE DEFAULT
-          found  = .FALSE.
-          grid_x = 'none'
-          grid_y = 'none'
-          grid_z = 'none'
-
-        END SELECT
+    var = TRIM(variable)
+!-- RTM directional variables
+    IF ( var(1:12) == 'rtm_rad_net_'  .OR.  var(1:13) == 'rtm_rad_insw_'  .OR.          &
+         var(1:13) == 'rtm_rad_inlw_'  .OR.  var(1:16) == 'rtm_rad_inswdir_'  .OR.      &
+         var(1:16) == 'rtm_rad_inswdif_'  .OR.  var(1:16) == 'rtm_rad_inswref_'  .OR.   &
+         var(1:16) == 'rtm_rad_inlwdif_'  .OR.  var(1:16) == 'rtm_rad_inlwref_'  .OR.   &
+         var(1:14) == 'rtm_rad_outsw_'  .OR.  var(1:14) == 'rtm_rad_outlw_'  .OR.       &
+         var(1:14) == 'rtm_rad_ressw_'  .OR.  var(1:14) == 'rtm_rad_reslw_'  .OR.       &
+         var == 'rtm_rad_pc_inlw'  .OR.                                                 &
+         var == 'rtm_rad_pc_insw'  .OR.  var == 'rtm_rad_pc_inswdir'  .OR.              &
+         var == 'rtm_rad_pc_inswdif'  .OR.  var == 'rtm_rad_pc_inswref'  .OR.           &
+         var(1:7) == 'rtm_svf'  .OR.  var(1:7) == 'rtm_dif'  .OR.                       &
+         var(1:9) == 'rtm_skyvf' .OR. var(1:10) == 'rtm_skyvft'  .OR.                   &
+         var == 'rtm_mrt'  .OR.  var ==  'rtm_mrt_sw'  .OR.  var == 'rtm_mrt_lw' )  THEN
+
+         found = .TRUE.
+         grid_x = 'x'
+         grid_y = 'y'
+         grid_z = 'zu'
+    ELSE
+
+       SELECT CASE ( TRIM( var ) )
+
+          CASE ( 'rad_lw_cs_hr', 'rad_lw_hr', 'rad_sw_cs_hr', 'rad_sw_hr',        &
+                 'rad_lw_cs_hr_xy', 'rad_lw_hr_xy', 'rad_sw_cs_hr_xy',            &
+                 'rad_sw_hr_xy', 'rad_lw_cs_hr_xz', 'rad_lw_hr_xz',               &
+                 'rad_sw_cs_hr_xz', 'rad_sw_hr_xz', 'rad_lw_cs_hr_yz',            &
+                 'rad_lw_hr_yz', 'rad_sw_cs_hr_yz', 'rad_sw_hr_yz',               &
+                 'rad_mrt', 'rad_mrt_sw', 'rad_mrt_lw' )
+             grid_x = 'x'
+             grid_y = 'y'
+             grid_z = 'zu'
+
+          CASE ( 'rad_lw_in', 'rad_lw_out', 'rad_sw_in', 'rad_sw_out',            &
+                 'rad_lw_in_xy', 'rad_lw_out_xy', 'rad_sw_in_xy','rad_sw_out_xy', &
+                 'rad_lw_in_xz', 'rad_lw_out_xz', 'rad_sw_in_xz','rad_sw_out_xz', &
+                 'rad_lw_in_yz', 'rad_lw_out_yz', 'rad_sw_in_yz','rad_sw_out_yz' )
+             grid_x = 'x'
+             grid_y = 'y'
+             grid_z = 'zw'
+
+
+          CASE DEFAULT
+             found  = .FALSE.
+             grid_x = 'none'
+             grid_y = 'none'
+             grid_z = 'none'
+
+           END SELECT
+       ENDIF
 
     END SUBROUTINE radiation_define_netcdf_grid
@@ -9649,9 +10114,48 @@
     REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf !<
 
+    CHARACTER (len=varnamelength)                   :: var, surfid
+    INTEGER(iwp)                                    :: ids,idsint_u,idsint_l,isurf,isvf,isurfs,isurflt,ipcgb
+    INTEGER(iwp)                                    :: is, js, ks, istat
+
     found = .TRUE.
 
-
-    SELECT CASE ( TRIM( variable ) )
-
+    ids = -1
+    var = TRIM(variable)
+    DO i = 0, nd-1
+        k = len(TRIM(var))
+        j = len(TRIM(dirname(i)))
+        IF ( TRIM(var(k-j+1:k)) == TRIM(dirname(i)) )  THEN
+            ids = i
+            idsint_u = dirint_u(ids)
+            idsint_l = dirint_l(ids)
+            var = var(:k-j)
+            EXIT
+        ENDIF
+    ENDDO
+    IF ( ids == -1 )  THEN
+        var = TRIM(variable)
+    ENDIF
+
+    IF ( (var(1:8) == 'rtm_svf_'  .OR.  var(1:8) == 'rtm_dif_')  .AND.  len(TRIM(var)) >= 13 )  THEN
+!--     svf values to particular surface
+        surfid = var(9:)
+        i = index(surfid,'_')
+        j = index(surfid(i+1:),'_')
+        READ(surfid(1:i-1),*, iostat=istat ) is
+        IF ( istat == 0 )  THEN
+            READ(surfid(i+1:i+j-1),*, iostat=istat ) js
+        ENDIF
+        IF ( istat == 0 )  THEN
+            READ(surfid(i+j+1:),*, iostat=istat ) ks
+        ENDIF
+        IF ( istat == 0 )  THEN
+            var = var(1:7)
+        ENDIF
+    ENDIF
+
+    local_pf = fill_value
+
+    SELECT CASE ( TRIM( var ) )
+!--   block of large scale radiation model (e.g. RRTMG) output variables
       CASE ( 'rad_sw_in' )
          IF ( av == 0 )  THEN
@@ -9838,60 +10342,275 @@
          ENDIF
 
-      CASE ( 'rad_mrt_sw' )
+!--   block of RTM output variables
+!--   variables are intended mainly for debugging and detailed analyse purposes
+      CASE ( 'rtm_skyvf' )
+!--        sky view factor
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = skyvf(isurf)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_skyvft' )
+!--      sky view factor
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == ids )  THEN
+               local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = skyvft(isurf)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_svf', 'rtm_dif' )
+!--      shape view factors or iradiance factors to selected surface
+         IF ( TRIM(var)=='rtm_svf' )  THEN
+             k = 1
+         ELSE
+             k = 2
+         ENDIF
+         DO isvf = 1, nsvfl
+            isurflt = svfsurf(1, isvf)
+            isurfs = svfsurf(2, isvf)
+
+            IF ( surf(ix,isurfs) == is  .AND.  surf(iy,isurfs) == js  .AND. surf(iz,isurfs) == ks  .AND. &
+                 (surf(id,isurfs) == idsint_u .OR. surfl(id,isurf) == idsint_l ) ) THEN
+!--            correct source surface
+               local_pf(surfl(ix,isurflt),surfl(iy,isurflt),surfl(iz,isurflt)) = svf(k,isvf)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_net' )
+!--     array of complete radiation balance
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = &
+                         surfinsw(isurf) - surfoutsw(isurf) +  surfinlw(isurf) - surfoutlw(isurf)
+               ELSE
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfradnet_av(isurf)
+               ENDIF
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_insw' )
+!--      array of sw radiation falling to surface after i-th reflection
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                 local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinsw(isurf)
+               ELSE
+                 local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinsw_av(isurf)
+               ENDIF
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_inlw' )
+!--      array of lw radiation falling to surface after i-th reflection
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinlw(isurf)
+               ELSE
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinlw_av(isurf)
+               ENDIF
+             ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_inswdir' )
+!--      array of direct sw radiation falling to surface from sun
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinswdir(isurf)
+               ELSE
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinswdir_av(isurf)
+               ENDIF
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_inswdif' )
+!--      array of difusion sw radiation falling to surface from sky and borders of the domain
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinswdif(isurf)
+               ELSE
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinswdif_av(isurf)
+               ENDIF
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_inswref' )
+!--      array of sw radiation falling to surface from reflections
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = &
+                    surfinsw(isurf) - surfinswdir(isurf) - surfinswdif(isurf)
+               ELSE
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinswref_av(isurf)
+               ENDIF
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_inlwdif' )
+!--      array of difusion lw radiation falling to surface from sky and borders of the domain
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinlwdif(isurf)
+               ELSE
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinlwdif_av(isurf)
+               ENDIF
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_inlwref' )
+!--      array of lw radiation falling to surface from reflections
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinlw(isurf) - surfinlwdif(isurf)
+               ELSE
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinlwref_av(isurf)
+               ENDIF
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_outsw' )
+!--      array of sw radiation emitted from surface after i-th reflection
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfoutsw(isurf)
+               ELSE
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfoutsw_av(isurf)
+               ENDIF
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_outlw' )
+!--      array of lw radiation emitted from surface after i-th reflection
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfoutlw(isurf)
+               ELSE
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfoutlw_av(isurf)
+               ENDIF
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_ressw' )
+!--      average of array of residua of sw radiation absorbed in surface after last reflection
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfins(isurf)
+               ELSE
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfins_av(isurf)
+               ENDIF
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_reslw' )
+!--      average of array of residua of lw radiation absorbed in surface after last reflection
+         DO isurf = dirstart(ids), dirend(ids)
+            IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+               IF ( av == 0 )  THEN
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinl(isurf)
+               ELSE
+                  local_pf(surfl(ix,isurf),surfl(iy,isurf),surfl(iz,isurf)) = surfinl_av(isurf)
+               ENDIF
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_pc_inlw' )
+!--      array of lw radiation absorbed by plant canopy
+         DO ipcgb = 1, npcbl
+            IF ( av == 0 )  THEN
+               local_pf(pcbl(ix,ipcgb),pcbl(iy,ipcgb),pcbl(iz,ipcgb)) = pcbinlw(ipcgb)
+            ELSE
+               local_pf(pcbl(ix,ipcgb),pcbl(iy,ipcgb),pcbl(iz,ipcgb)) = pcbinlw_av(ipcgb)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_pc_insw' )
+!--      array of sw radiation absorbed by plant canopy
+         DO ipcgb = 1, npcbl
+            IF ( av == 0 )  THEN
+              local_pf(pcbl(ix,ipcgb),pcbl(iy,ipcgb),pcbl(iz,ipcgb)) = pcbinsw(ipcgb)
+            ELSE
+              local_pf(pcbl(ix,ipcgb),pcbl(iy,ipcgb),pcbl(iz,ipcgb)) = pcbinsw_av(ipcgb)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_pc_inswdir' )
+!--      array of direct sw radiation absorbed by plant canopy
+         DO ipcgb = 1, npcbl
+            IF ( av == 0 )  THEN
+               local_pf(pcbl(ix,ipcgb),pcbl(iy,ipcgb),pcbl(iz,ipcgb)) = pcbinswdir(ipcgb)
+            ELSE
+               local_pf(pcbl(ix,ipcgb),pcbl(iy,ipcgb),pcbl(iz,ipcgb)) = pcbinswdir_av(ipcgb)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_pc_inswdif' )
+!--      array of diffuse sw radiation absorbed by plant canopy
+         DO ipcgb = 1, npcbl
+            IF ( av == 0 )  THEN
+               local_pf(pcbl(ix,ipcgb),pcbl(iy,ipcgb),pcbl(iz,ipcgb)) = pcbinswdif(ipcgb)
+            ELSE
+               local_pf(pcbl(ix,ipcgb),pcbl(iy,ipcgb),pcbl(iz,ipcgb)) = pcbinswdif_av(ipcgb)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_rad_pc_inswref' )
+!--      array of reflected sw radiation absorbed by plant canopy
+         DO ipcgb = 1, npcbl
+            IF ( av == 0 )  THEN
+               local_pf(pcbl(ix,ipcgb),pcbl(iy,ipcgb),pcbl(iz,ipcgb)) = &
+                                    pcbinsw(ipcgb) - pcbinswdir(ipcgb) - pcbinswdif(ipcgb)
+            ELSE
+               local_pf(pcbl(ix,ipcgb),pcbl(iy,ipcgb),pcbl(iz,ipcgb)) = pcbinswref_av(ipcgb)
+            ENDIF
+         ENDDO
+
+      CASE ( 'rtm_mrt_sw' )
          local_pf = REAL( fill_value, KIND = wp )
          IF ( av == 0 )  THEN
             DO  l = 1, nmrtbl
-               i = mrtbl(ix,l)
-               j = mrtbl(iy,l)
-               k = mrtbl(iz,l)
-               local_pf(i,j,k) = mrtinsw(l)
+               local_pf(mrtbl(ix,l),mrtbl(iy,l),mrtbl(iz,l)) = mrtinsw(l)
             ENDDO
          ELSE
             IF ( ALLOCATED( mrtinsw_av ) ) THEN
                DO  l = 1, nmrtbl
-                  i = mrtbl(ix,l)
-                  j = mrtbl(iy,l)
-                  k = mrtbl(iz,l)
-                  local_pf(i,j,k) = mrtinsw_av(l)
+                  local_pf(mrtbl(ix,l),mrtbl(iy,l),mrtbl(iz,l)) = mrtinsw_av(l)
                ENDDO
             ENDIF
          ENDIF
 
-      CASE ( 'rad_mrt_lw' )
+      CASE ( 'rtm_mrt_lw' )
          local_pf = REAL( fill_value, KIND = wp )
          IF ( av == 0 )  THEN
             DO  l = 1, nmrtbl
-               i = mrtbl(ix,l)
-               j = mrtbl(iy,l)
-               k = mrtbl(iz,l)
-               local_pf(i,j,k) = mrtinlw(l)
+               local_pf(mrtbl(ix,l),mrtbl(iy,l),mrtbl(iz,l)) = mrtinlw(l)
             ENDDO
          ELSE
             IF ( ALLOCATED( mrtinlw_av ) ) THEN
                DO  l = 1, nmrtbl
-                  i = mrtbl(ix,l)
-                  j = mrtbl(iy,l)
-                  k = mrtbl(iz,l)
-                  local_pf(i,j,k) = mrtinlw_av(l)
+                  local_pf(mrtbl(ix,l),mrtbl(iy,l),mrtbl(iz,l)) = mrtinlw_av(l)
                ENDDO
             ENDIF
          ENDIF
 
-      CASE ( 'rad_mrt' )
+      CASE ( 'rtm_mrt' )
          local_pf = REAL( fill_value, KIND = wp )
          IF ( av == 0 )  THEN
             DO  l = 1, nmrtbl
-               i = mrtbl(ix,l)
-               j = mrtbl(iy,l)
-               k = mrtbl(iz,l)
-               local_pf(i,j,k) = mrt(l)
+               local_pf(mrtbl(ix,l),mrtbl(iy,l),mrtbl(iz,l)) = mrt(l)
             ENDDO
          ELSE
             IF ( ALLOCATED( mrt_av ) ) THEN
                DO  l = 1, nmrtbl
-                  i = mrtbl(ix,l)
-                  j = mrtbl(iy,l)
-                  k = mrtbl(iz,l)
-                  local_pf(i,j,k) = mrt_av(l)
+                  local_pf(mrtbl(ix,l),mrtbl(iy,l),mrtbl(iz,l)) = mrt_av(l)
                ENDDO
             ENDIF
